/* history

9-27-96	Put in the fseek() stuff... so we can determine the size of a message.
		part numbers in the header.
version .05

*/

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dos.h>
#include  <dir.h>
#include  <time.h>
#include  <io.h>
#include  "..\stat\pragmas.h"

#define	LABELSIZE	30

typedef char label[LABELSIZE+1];

time_t	timestamp;

FILE	*in, *out;

fpos_t	pos_start, pos_end;

static  char *endstring[] = {
        "From ",          /* 0 */
        "Article ",       /* 1 */
        NULL
        };

label	SID,		// Source ID
		stamp,		// Time Stamp
		name,
		title,
		surname,
		group,
		phone,
		twit_region,
		twit_country,
		mail_to,		// Mail- recipient
		node_to,      // Mail- node to send mail to
		address_to,      // '>' Mail- Address of node to send mail to
		public_to,      // 'f' Public- Public TO field.
		realname,
		fromnode,
		fromaddress,
		room,
		state,
		region;

label   version    = "Unix->69 0.05";

long	fuckedtime,
        filesize   = 0,
		totalparts = 0,
		message_len = 0;

int		ID,						// Local ID field.  Ignored by Citadel.
		debug	 = 0,
        spaces   = 1,
        unixgate = 0,           // 1 = try to gate unix mail file.
        part     = 0,
		partsize = 7500;		// Part size.  Default = 7500. configurable.

char    progname[257];

char    temptext[513];

char    input[257],				// Input file.
		configfile[257],
		messagetext[8193],		// The main body of the message.
		subject[81],			// Subject of the messages...
		sig1[81],				// User Signature line.
		sig2[81],				// BBS Signature line.
		cmt_address[257],
		cmt_from[257],
		cmt_date[257],
		cmt_subject[257],
		cmt_to[257],
		cmt_lines[257],
		cmt_msgid[257],
		cmt_newsgroups[257],
		cmt_size[257],
		gateway[257]	= "";	// The '*' gateway field.

void	startup(void);
int		config(void);
void 	putmsg(void);
void    header(void);
int     isend(char *str);
int 	GetStr(char *str, int mlen);
void 	PutStr(FILE *fl, char *str);
void 	PutStr1(FILE *fl, char *str);
void	usage(void);

/* Main */
int main(int argc, char *argv[])
{
int		done = 0, length;

    strcpy(progname, strlwr(argv[0]));

	printf("\n"
		   "%s (%s %s)\n"
		   "\n"
		   "By Magrathea @ Skaro, Olympia [skr.olm]\n"
		   "amalmin@halcyon.com\n"
		   "\n", version, __TIME__, __DATE__);

	if(argc < 2)
	{
		usage();
		exit(1);
	}

	SID[0]			= 0;
	stamp[0]        = 0;
	name[0]     	= 0;
	title[0]    	= 0;
	surname[0]    	= 0;
	group[0]     	= 0;
	phone[0]     	= 0;
	twit_region[0] 	= 0;
	twit_country[0]	= 0;
	mail_to[0]     	= 0;
	node_to[0]     	= 0;
	address_to[0]  	= 0;
	public_to[0]   	= 0;
	realname[0]    	= 0;
	fromnode[0]    	= 0;
	fromaddress[0] 	= 0;
	room[0]	     	= 0;
	state[0]     	= 0;
	region[0]      	= 0;
    temptext[0]		= 0;

	strcpy(configfile, "unix.cfg");

	config();

	strcpy(input, argv[1]);

	if(argc > 2)
		strcpy(room, argv[2]);

    if(argc > 3)
        if(stricmp(argv[3], "-Mail") == 0)
             {
             printf("No formatting control.\n");
             spaces = 0;
             }

	startup();

	if(filesize == 0)
	{
		printf("Duh...you're input file \"%s\" is empty...\n", input);
		exit(1);
	}

	printf("\n"
           "Room: %s\n",
           room);

	time(&timestamp);
	fuckedtime = timestamp;

	sprintf(SID, "%ld", timestamp);

        do	/* Main loop... */
		{
            *name 		 	= 0;
			*cmt_address 	= 0;
			*cmt_from	 	= 0;
			*cmt_date	 	= 0;
			*cmt_subject 	= 0;
			*cmt_to		 	= 0;
			*cmt_lines	 	= 0;
			*cmt_msgid	 	= 0;
			*cmt_newsgroups	= 0;
			*cmt_size		= 0;
            *subject 	 	= 0;
            *public_to	 	= 0;
			*sig2			= 0;
			message_len		= 0;
            part 		 	= 0;
			totalparts		= 0;

			printf("----\n");

            header();	/* Get the Header information... */

			fgetpos(in, &pos_start);	/* get message size */

			do
			{
            fgets(temptext, 512, in);
            } while(!feof(in) && !isend(temptext));

			fgetpos(in, &pos_end);
			fsetpos(in, &pos_start);

			message_len = pos_end - pos_start;	/* got message size */
			totalparts = (message_len / partsize) + 1;

			printf("Message length: %ld (%ld part%s)\n",
				    message_len, totalparts, (totalparts > 1) ? "s" : "");

            do
            {
                *messagetext = 0;
				*sig2		 = 0;

                if(spaces)
                   strcat(messagetext, "5");

				/* get one partsize of message text */
                for(length = 0; length < partsize; length += strlen(temptext))
                {
                    fgets(temptext, 512, in);

                    if(!isend(temptext))
                        strcat(messagetext, temptext);
                    else								/* end of message */
                        length = partsize + 1;

                    if(feof(in))
                        break;

                    if(temptext[0] == '\n')
                        done = 1;
                }

                putmsg();

            } while(!feof(in) && (done != 0 && !isend(temptext)));

			if(debug)
	            printf("Ending text: %s\n", temptext);

            if(feof(in))
                return(0);

		} while(!feof(in));

	return(0);
}

/* ------------------------------------------------------------------------ */
/*  putmsg() -- Writes a message out to the 'out' stream.                   */
/* ------------------------------------------------------------------------ */
void putmsg(void)
{
	part++;
	printf("writing message # %d of %ld\n", part, totalparts);

	fuckedtime++;                     /* defeat cit's dup checking. */
	sprintf(SID, "%ld", fuckedtime);  /* uses the time as the source id...*/

	time(&timestamp);				  /* make the timestamp */
	sprintf(stamp, "%ld", timestamp);

	if(totalparts > 1)
		sprintf(cmt_size, "%ld bytes total, %u bytes this part, Part %d of %ld.",
				message_len, strlen(messagetext), part, totalparts);
	else
		sprintf(cmt_size, "%ld bytes. (complete)", message_len);

	if(totalparts - part)
		strcpy(sig2, "[Multi-part message continues below]");

	/* write start of message */
	fputc(0xFF, out);			/* 0xFF to start things off... */
	fputc(0x00, out);			/* fake the attribute bits... */
	PutStr(out, SID);			/* put local ID # out */

	fputc('D', out); PutStr(out, stamp);		/* timestamp */
	fputc('A', out); PutStr(out, name);			/* author */
	fputc('O', out); PutStr(out, fromnode);     /* node */
	fputc('S', out); PutStr(out, SID);          /* source ID */
	fputc('P', out); PutStr(out, fromaddress);  /* node address */
	fputc('s', out); PutStr(out, version);      /* software version */

	/* all the possible normal fields... */
	if(region[0])       { fputc('o', out); PutStr(out, region);      	}
	if(state[0])        { fputc('Q', out); PutStr(out, state);	    	}
	if(subject[0])      { fputc('B', out); PutStr(out, subject);     	}
	if(title[0])        { fputc('N', out); PutStr(out, title);       	}
	if(surname[0])      { fputc('n', out); PutStr(out, surname);		}
	if(group[0])        { fputc('G', out); PutStr(out, group);       	}
	if(phone[0])        { fputc('H', out); PutStr(out, phone);       	}
	if(twit_region[0])  { fputc('J', out); PutStr(out, twit_region); 	}
	if(twit_country[0]) { fputc('j', out); PutStr(out, twit_country);	}
	if(mail_to[0])      { fputc('T', out); PutStr(out, mail_to);     	}
	if(node_to[0])      { fputc('Z', out); PutStr(out, node_to);     	}
	if(address_to[0])   { fputc('>', out); PutStr(out, address_to);  	}
	if(public_to[0])    { fputc('t', out); PutStr(out, public_to);  	}
	if(realname[0])     { fputc('!', out); PutStr(out, realname);   	}
	if(sig1[0])         { fputc('_', out); PutStr(out, sig1);        	}
	if(sig2[0])			{ fputc('.', out); PutStr(out, sig2);        	}

	/* All the possible comment fields. */
	fputc('%', out); PutStr(out, cmt_size);		/* part number, size line */

	if(cmt_to[0])		{ fputc('%', out); PutStr(out, cmt_to);			}
	if(cmt_subject[0])	{ fputc('%', out); PutStr(out, cmt_subject);	}
	if(cmt_date[0])		{ fputc('%', out); PutStr(out, cmt_date);		}
	if(cmt_from[0])		{ fputc('%', out); PutStr(out, cmt_from);		}
	if(cmt_address[0])	{ fputc('%', out); PutStr(out, cmt_address);	}
	if(cmt_lines[0])	{ fputc('%', out); PutStr(out, cmt_lines);		}
	if(cmt_newsgroups[0])	{ fputc('%', out); PutStr(out, cmt_newsgroups);		}
	if(cmt_msgid[0])	{ fputc('%', out); PutStr(out, cmt_msgid);		}

	/* And finally the message text. */
	fputc('M', out); PutStr(out, messagetext);
}

/******************************/
/* header                     */
/******************************/
void header(void)
{
    do
    {
        fgets(temptext, 512, in);

		if(temptext[0] == '\n')
			break;

        temptext[strlen(temptext) - 1] = 0; // clip return.

        if(strncmpi(temptext, "From: ", 6) == 0)
        	{
			char	*bracket = NULL;
			char	*endbrket = NULL;

			if((bracket = strchr(temptext, '<')) != 0)
				{
				*(bracket-1) = 0;

				if((endbrket = strchr(bracket + 1, '>')) != 0)
					*endbrket = 0;

				strcpy(name, temptext + 6);
				strcpy(cmt_address, "3Address:0 ");
				strcat(cmt_address, bracket + 1);
				}
			else
				{
				bracket = NULL;
				endbrket = NULL;

				if((bracket = strchr(temptext, '(')) != 0)
					{
					*(bracket-1) = 0;

					if((endbrket = strchr(bracket + 1, ')')) != 0)
						*endbrket = 0;

					strcpy(cmt_address, "3Address:0 ");
					strcat(cmt_address, temptext + 6);
					strcpy(name, bracket + 1);
					}
				else
					{
					if (strlen(temptext) >= 36)
						{
						temptext[200] = 0;
						strcpy(cmt_from, "53Full address/author:0 ");
						strcat(cmt_from, temptext);
						}
		            temptext[36] = 0;
	    	        strcpy(name, temptext + 6);
					}
				}

            printf("Name: %s\nAddress: %s\n",
                   name, cmt_address);
        } /* end From */
        else
            if(strncmpi(temptext, "Subject: ", 9) == 0)
            {
				if(strlen(temptext) <= 89)
					{
					temptext[89] = 0;
	                strcpy(subject, temptext + 9);
    	            printf("Subject: %s\n", subject);
					}
				else
					{
					temptext[251] = 0;
					strcpy(cmt_subject, "3Subject:0 ");
                    strcat(cmt_subject, temptext + 9);
					printf("Long Sub: %s\n", cmt_subject);
					}
            } /* end Subject */
            else
                if(strncmpi(temptext, "To: ", 4) == 0)
                {
					if(strlen(temptext) <= 34)
						{
            	        temptext[34] = 0;
        	            strcpy(public_to, temptext + 4);
    	                printf("To: %s\n", public_to);
						}
					else
						{
						temptext[251] = 0;
						strcpy(cmt_to, "3To:0 ");
						strcat(cmt_to, temptext + 4);
						printf("Long To: %s\n", cmt_to);
						}
                } /* end To */
                else
                    if(strncmp(temptext, "Date: ", 6) == 0)
                    {
                        temptext[201] = 0;
                        strcpy(cmt_date, "3Message date:0 ");
                        strcat(cmt_date, temptext + 6);
                    }
					else
						if(strncmpi(temptext, "Lines: ", 7) == 0)
							{
							temptext[201] = 0;
							strcpy(cmt_lines, "3Lines:0 ");
							strcat(cmt_lines, temptext + 7);
							}
						else
							if(strncmpi(temptext, "Message-id: ", 12) == 0)
								{
								temptext[200] = 0;
								strcpy(cmt_msgid, "53Message-id:a ");
								strcat(cmt_msgid, temptext + 12);
								strcat(cmt_msgid, "0");
								}
							else
								if(strncmpi(temptext, "Newsgroups: ", 12) == 0)
    								{
									temptext[231] = 0;
									strcpy(cmt_newsgroups, "53Newsgroups:0 ");
									strcat(cmt_newsgroups, temptext + 12);
									}
    } while(temptext[0] != '\n' && !feof(in));
}


/* -------------------------------------------------------------------- */
/*  GetStr() - Gets an mlen length chunk of text from the text file.    */
/* -------------------------------------------------------------------- */
int GetStr(char *str, int mlen)
{
	int	l = 0;
	unsigned char ch = 1;

	while(!feof(in) && l <mlen)
	{
		ch=(unsigned char)fgetc(in);
		if (!feof(in) && l < mlen)
		{
			str[l]=ch;
			l++;
		}
	}
	str[l]='\0';

	if(!feof(in))
		return 0;
	else
		return 1;
}

/* -------------------------------------------------------------------- */
/*  PutStr()        puts a null-terminated string to a file             */
/* -------------------------------------------------------------------- */
/*					This is from DragCit.								*/
/* -------------------------------------------------------------------- */
void PutStr(FILE *fl, char *str)
{
	fwrite(str, sizeof(char), (strlen(str) + 1), fl);
}

/* Same as above...  but without the null... */
void PutStr1(FILE *fl, char *str)
{
	fwrite(str, sizeof(char), strlen(str), fl);
}

/* -------------------------------------------------------------------- */
/*  startup()  --  startup...  opens all files.                         */
/* -------------------------------------------------------------------- */
void startup(void)
{
	if ((in = fopen(input, "rb")) == NULL)
	{
		printf("\n\n Hmm...  I can't seem to find \"%s\".\n", input);
		exit(1);
	}

	if ((out = fopen("msg.69", "wb")) == NULL)
	{
		printf("\n\n I need to write to \"MSG.69\", but I can't seem to open it.\n"
			   "Append mode has to be on if you want to add to an old packet.\n");
		exit(1);
	}

	filesize = filelength(fileno(in));

	PutStr(out, fromaddress);		// Output the address.
	PutStr(out, room);              // And the roomname.
}

/* ------------------------------------------------------------------- */
/* config()  --  Reads a config file.                                  */
/* ------------------------------------------------------------------- */
int config(void)
{
	int i;
	FILE *cfg;
	char line[257], word1[257], lword1[257];
	char *text;
	char drive[5] = "", dir[257] = "";

	static char *KEYWORD[] = {
		"AUTHOR",				/* 0  - 'A'uthor field            */
		"NODE",                 /* 1  - 'O'riginating Node        */
		"ADDRESS",      		/* 2  - first entry in 'P'ath     */
		"REGION",	        	/* 3  - 'o' region field          */
		"DEFAULT_ROOM",         /* 4  - 'R' field                 */
		"UNIX_MAIL",            /* 5  - start after first blank line */
		"DELAYED_START",        /* 6  - line number to start on   */
		"START_STRING",         /* 7  - The string to start with  */
		"SUBJECT",              /* 8  - 'B' Subject field         */
		"END_STRING",           /* 9  - The string to end with    */
		"COMMENT",              /* 10 - '%' comment field (any #) */
		"TITLE",                /* 11 - 'N' Title field           */
		"SURNAME",              /* 12 - 'n' Surname field         */
		"SIGNATURE1",			/* 13 - '_' User Sig field        */
		"SIGNATURE2",           /* 14 - '.' BBS Sig field         */
		"GROUP",                /* 15 - 'G'roup field             */
		"PHONE",                /* 16 - 'H' Phone number field    */
		"TWIT_REGION", 			/* 17 - 'J' Twit region field     */
		"TWIT_COUNTRY",         /* 18 - 'j' Twit country field    */
		"MAIL_TO_USER",         /* 19 - E-Mail 'T'o field         */
		"FORCED_PATH",          /* 20 - 'p' forced path field     */
		"REAL_NAME",            /* 21 - '!' Real name field       */
		"MAIL_TO_NODE",         /* 22 - 'Z' Destination node name */
		"MAIL_TO_ADD",          /* 23 - '>' Destination address   */
		"COUNTRY",				/* 24 - 'Q' county/state field    */
		"PUBLIC_TO",			/* 25 - 't' public 'to' field     */
		"FORMATTING",			/* 26 - if 1 then don't use ^A5   */
		"PART_SIZE",			/* 27 - the size of one message.  */
		"GATEWAY",				/* 28 - the '*' gateway field.    */
		"APPEND",				/* 29 - allow posting of multiple files. */
		"COMP",					/* 30 - send message to an extra file.. */
        "unixgate",             // 31
		"debug",				// 32
		NULL
		};


	if ((cfg = fopen (configfile, "rt")) == NULL)
	{
		fnsplit(progname, drive, dir, NULL, NULL);
		sprintf(configfile, "%s%sposter.cfg", drive, dir);
		printf("Config file might be: %s\n\n", configfile);
		if((cfg = fopen(configfile, "rt")) == 0)
		{
			printf ("No config file present.\n\n");
			return 0;
		}
	}
	else
	{
		printf("Config file \"%s\" found.\n\n", configfile);
	}

	while (!feof (cfg))
	{
		text = fgets(line, sizeof(line), cfg);
		if(text == 0)
			break;
		if(line[0] != '#')
			continue;

		i = sscanf(line, "%s \"%255[^\"\n\r\t]", word1, lword1);

		if(i == 1)
			i = sscanf(line, "%s %255s", word1, lword1);
		if(i != 2)
			continue;

		for(i = 0; KEYWORD[i] != NULL; i++)
			if(stricmp(&word1[1], KEYWORD[i]) == 0)
			   break;

		switch (i)
		{
			case 0:
				break;
			case 1:
				lword1[31] = 0;
				strcpy(fromnode, lword1);
				break;
			case 2:
				lword1[31] = 0;
				strcpy(fromaddress, lword1);
				break;
			case 3:
				lword1[31] = 0;
				strcpy(region, lword1);
				break;
			case 4:
				lword1[31] = 0;
				strcpy(room, lword1);
				break;
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11:
			case 12:
				break;
			case 13:
				lword1[81] = 0;
				strcpy(sig1, lword1);
				break;
			case 14:
				lword1[81] = 0;
				strcpy(sig2, lword1);
				break;
			case 15:
				lword1[31] = 0;
				strcpy(group, lword1);
				break;
			case 16:
				lword1[31] = 0;
				strcpy(phone, lword1);
				break;
			case 17:
				lword1[31] = 0;
				strcpy(twit_region, lword1);
				break;
			case 18:
				lword1[31] = 0;
				strcpy(twit_country, lword1);
				break;
			case 19:
				lword1[31] = 0;
				strcpy(mail_to, lword1);
				break;
			case 20:
			case 21:
				break;
			case 22:
				lword1[31] = 0;
				strcpy(node_to, lword1);
				break;
			case 23:
				lword1[8] = 0;
				strcpy(address_to, lword1);
				break;
			case 24:
				lword1[31] = 0;
				strcpy(state, lword1);
				break;
			case 25:
			case 26:
				break;
			case 27:
				partsize = atoi(lword1);
				break;
			case 28:
			case 29:
			case 30:
				break;

            case 31:
                 unixgate = 1;
                 break;

			case 32:
				if(!strcmp(lword1, "1"))
					debug = 1;
				break;

			 default:
				printf("Keyword '%s' unknown.\n", word1);
				break;
		}
	}
	fclose(cfg);
	return 1;
}

/****************************************************************************/
/* usage()                                                                  */
/****************************************************************************/
void usage(void)
{
	printf("Usage: %s filename room [-Mail]\n"
		   "\n"
	       "	  room == room messages show up in.\n"
           "     -Mail == excludes ^A5 from the output messages.  (This MUST be the\n"
           "              second argument...so you need a roomname to use it.)\n"
	       "\n"
	       "Any multi-word args MUST be in quotes.\n\n", progname);
}

/****************************************************************************/
/* int     isend(char *str)                                                 */
/****************************************************************************/
int     isend(char *str)
{
int i = 0;

    for(i = 0; endstring[i] != NULL; i++)
    {
        if(strncmp(str, endstring[i], strlen(endstring[i])) == 0)
        {
			if(debug)
	            printf("Found end of message: %50.50s\n", str);
            return 1;
        }
    }
    return 0;
}